version: "3.5"
services:
        user:
                image: mymobiconf/userservice
                build: # build local Dockerfile
                        context: .
                        dockerfile: Dockerfile
                restart: on-failure # restart if this container fails
                deploy: # on swarm mode...
                        replicas: 6 # starts with 6 replicas of this container
                        restart_policy:
                                condition: on-failure # restart if this container fails
                                delay: 5s # wait 5 seconds until restarting process
                        update_config: # on update...
                                parallelism: 2 # updates two replicas at a time
                                failure_action: rollback # if deploy fails, rollback
                                monitor: 1s # wait 1 second for deploy failures
                                order: start-first # start the new version b4 closing the old one
                networks: # connect to
                        - services_net
                        - mongo_net
                depends_on: # wait mongodb starts and migrate
                        - user-mongo
                ports: # expose port 5000 to host port 84
                        - "84:5000"
        user-mongo:
                image: mongo:4-bionic # fetch  image
                networks: # connect to flask
                        - mongo_net
                restart: on-failure # restart if this container fails
                deploy: # on swarm mode...
                        placement:
                                constraints: [node.role == manager]
                volumes: # makes mongo data persistent between updates
                        - mongo-volume:/data/db
networks:
        services_net: # "event service replicas <-> other services" network
                external: true
        mongo_net: # "event <-> mysql <-> mysql-migration" network
volumes:
        mongo-volume: # mysql data persistence volume
